unit ubaum;

interface

uses dialogs;

type

tzeiger=^knoten;// typisierter Zeiger

knoten=record
  daten:string;
  links,rechts:tzeiger;
end;

tbaum=class
private
 zneu,zhilf,zwurzel:tzeiger;
 ausgabe:string;
public
 procedure neu_dazu(s:string);
 procedure einordnen;
 procedure pre_order(z:tzeiger);
 procedure in_order(z:tzeiger);
 procedure post_order(z:tzeiger);
 function ausgeben(mode:string):string;

end;

implementation

procedure tbaum.neu_dazu(s: string);
begin
  new(zneu);
  zneu^.daten:=s;
  zneu^.links:=nil;
  zneu^.rechts:=nil;
  if zwurzel=nil then zwurzel:=zneu else
   begin
     zhilf:=zwurzel;
     einordnen;
   end;
end;

procedure tbaum.einordnen;
begin
 if zneu^.daten>zhilf^.daten then
  begin
    //showmessage('Rechts nach Vergleich mit '+zhilf^.daten);
    if zhilf^.rechts=nil then zhilf^.rechts:=zneu
    else begin
          zhilf:=zhilf^.rechts;
          einordnen;
         end;
  end
 else
  begin
    //showmessage('Links nach Vergleich mit '+zhilf^.daten);
    if zhilf^.links=nil then zhilf^.links:=zneu
    else begin
          zhilf:=zhilf^.links;
          einordnen;
         end;
  end;
end;

procedure tbaum.pre_order(z:tzeiger);
begin
 if z<>nil then
  begin
    ausgabe:=ausgabe+z^.daten+' ';
    pre_order(z^.links);
    pre_order(z^.rechts);
  end;
end;

procedure tbaum.in_order(z:tzeiger);
begin
 if z<>nil then
  begin
    pre_order(z^.links);
    ausgabe:=ausgabe+z^.daten+' ';
    pre_order(z^.rechts);
  end;
end;

procedure tbaum.post_order(z:tzeiger);
begin
 if z<>nil then
  begin
    pre_order(z^.links);
    pre_order(z^.rechts);
    ausgabe:=ausgabe+z^.daten+' ';
  end;
end;

function tbaum.ausgeben(mode:string):string;
begin
  ausgabe:='';
  if zwurzel=nil  then showmessage('Leer!') else
  begin
  zhilf:=zwurzel;
  if mode='pre' then pre_order(zhilf) else
  if mode='post' then post_order(zhilf) else
  if mode='in' then in_order(zhilf) ;
  end;
  result:=ausgabe;
end;

end.
